
type Representable = string|number|boolean;

type ToQueryStringA = {
    [name:string]:Representable|Representable[]|undefined
};

export const toQueryString = (obj:ToQueryStringA)=> {
    return Object.entries(obj)
        .filter((e): e is [string,Representable|Representable[]] => 
                e[1] !== undefined)
        .map(e => 
        e[1] instanceof Array 
            ? e[1].map(f=>`${e[0]}=${(f)}`).join('&') 
            : `${e[0]}=${(e[1])}`)
        .join('&');
}
export const QueryStringToMap = (query:string) =>{
    const keyValue = query.slice(query.indexOf("?")+1).split("&");
    const param:{[k:string]:string|string[]} = {};
    keyValue.forEach((p)=>{
        const [k,v] = p.split("=");
        const pv = param[k];
        if(pv === undefined){
            param[k] = v;
        }
        else if(typeof pv === "string"){
            param[k] = [pv,v];
        }
        else{
            pv.push(v);
        }
    });
    return param;
}