import React, { useContext, useEffect, useState } from 'react';
import { CommonMenuList, Headline } from "../component/mod";
import { UserContext } from "../state";
import { Box, Grid, Paper, Typography,Button, makeStyles, Theme } from "@material-ui/core";

const useStyles = makeStyles((theme:Theme)=>({
    paper:{
        padding: theme.spacing(2),
    },
    commitable:{
        display:'grid',
        gridTemplateColumns: `100px auto`,
    },
    contentTitle:{
        marginLeft: theme.spacing(2)
    }
}));
type FileDifference = {
    type:string,
    value:{
        type:string,
        path:string,
    }[]
}


function TypeDifference(prop:{
    content:FileDifference,
    onCommit:(v:{type:string,path:string})=>void
}){
    const classes = useStyles();
    const x = prop.content;
    return (<Paper className={classes.paper}>
                    <Typography variant='h3' className={classes.contentTitle}>{x.type}</Typography>
                        {x.value.map(y=>(
                    <Box className={classes.commitable} key={y.path}>
                            <Button onClick={()=>prop.onCommit(y)}>Commit</Button>
                            <Typography variant='h5'>{y.path}</Typography>
                    </Box>
                            ))}
                </Paper>);
}

export function DifferencePage(){
    const ctx = useContext(UserContext);
    const classes = useStyles();
    const [diffList,setDiffList] = useState<
    FileDifference[]
    >([]);
    const doLoad = async ()=>{
        const list = await fetch('/api/diff/list');
        if(list.ok){
            const inner = await list.json();
            setDiffList(inner);
        }
        else{
            //setDiffList([]);
        }
    };
    const Commit = async(x:{type:string,path:string})=>{
        const res = await fetch('/api/diff/commit',{
            method:'POST',
            body: JSON.stringify([{...x}]),
            headers:{
                'content-type':'application/json'
            }
        });
        const bb = await res.json();
        if(bb.ok){
            doLoad();
        }
    } 
    useEffect(
        ()=>{
            doLoad();
            const i = setInterval(doLoad,5000);
            return ()=>{
                clearInterval(i);
            }
        },[]
    )
    const menu = CommonMenuList();
    return (<Headline menu={menu}>
        {(ctx.username == "admin") ? (<div>
            {(diffList.map(x=>
                <TypeDifference key={x.type} content={x} onCommit={Commit}/>))}
        </div>)
        :(<Typography variant='h2'>Not Allowed : please login as an admin</Typography>)
        }
    
    </Headline>)
}