const path = require("path");
const MiniCssExtractPlugin = require('mini-css-extract-plugin');

module.exports = ()=>{return {
    entry: './app.tsx',
    output: {
        path: path.resolve(__dirname, '../../dist/js'),
        filename: 'bundle.js'
    },
    module: {
        rules: [
            {
                test: /\.(js|ts|tsx)$/,
                exclude: /node_modules/,
                use: {
                    loader: 'babel-loader',
                    options: {
                        babelrc: true,//why babelrc not working? why is webpack not reading '.babelrc'?
                        presets: [
                          '@babel/preset-env',
                          '@babel/preset-typescript',
                          '@babel/preset-react'
                        ],
                        plugins: [
                          '@babel/proposal-class-properties',
                          '@babel/proposal-object-rest-spread'
                        ]
                      }
                }
            },
            {
                test: /\.css$/,
                use: [MiniCssExtractPlugin.loader,'css-loader']
            }
        ]
    },
    plugins : [
        new MiniCssExtractPlugin({
            "filename":'../css/style.css'}),
    ],
    devtool: 'source-map',
    resolve: {
        extensions: ['.js','.css','.ts','.tsx']
    }
};}